#include "hero.h"
#include "time.h"

#define JUMP_DY -5
#define JUMP_AY 0.45

Hero * hero_create(unsigned char ** bmp) {
	Hero * hero = (Hero *) malloc(sizeof(Hero));	
	hero->x = 10;	
	hero->y = 36;
	hero->dx = 0;	
	hero->dy = 0;
	hero->ax = 0;	
	hero->ay = 0;
	hero->x_stop = -1;
	hero->y_stop = -1;
	hero->bmp = bmp;
	hero->anim_tick = 0;
	hero->anim_bmp = 1;
	hero->anim_isjmp = 0;
	hero->anim_isfall = 0;
	hero->last_update = 0;
	return hero;
}
void hero_reset(Hero * hero) {
	hero->x = 10;	
	hero->y = 36;
	hero->dx = 0;	
	hero->dy = 0;
	hero->ax = 0;	
	hero->ay = 0;
	hero->x_stop = -1;
	hero->y_stop = -1;
	hero->anim_tick = 0;
	hero->anim_bmp = 1;
	hero->anim_isjmp = 0;
	hero->anim_isfall = 0;
	hero->last_update = 0;
}
void hero_jump_start(Hero * hero) {
	if(!hero->anim_isjmp) {
		hero->dy = JUMP_DY;
		hero->ay = JUMP_AY;		
		hero->anim_isjmp = 1;
		hero->anim_bmp = 3;
	}
}
void hero_jump_reset(Hero * hero) {
	if(hero->anim_isjmp) {
		hero->dy = 0;
	}
}
void hero_jump_stop(Hero * hero, int y) {
	if(hero->anim_isjmp) {		
		hero->y = y;
		hero->dy = 0;
		hero->ay = 0;
		hero->anim_isjmp = 0;
		hero->anim_isfall = 0;
		hero->anim_bmp = 1;
	}
}
void hero_falling_start(Hero * hero) {
	if(!hero->anim_isjmp) {
		hero->ay = JUMP_AY;		
		hero->anim_isjmp = 1;
		hero->anim_isfall = 1;
		hero->anim_bmp = 3;
	}
}
void hero_update(Hero * hero) {
	if(time_getTicks() - hero->last_update > 2) {
		hero->dx += hero->ax;
		hero->dy += hero->ay ;
		
		hero->x += hero->dx;
		hero->y += hero->dy;
		hero->last_update = time_getTicks();
	}
	
	if(time_getTicks()-hero->anim_tick > 15) {
		hero->anim_tick = time_getTicks();
		if(!hero->anim_isjmp && hero->anim_bmp == 1)
			hero->anim_bmp = 2;
		else if(!hero->anim_isjmp && hero->anim_bmp == 2)
			hero->anim_bmp = 1;
	}
}